;lol






















































































;This sprite is entitled "Can of Soda"
;By: Chdata/Fakescaper, credit Chdata
;GFX By: Kunio, credit him if you use them
;The extra bit being set to 3 makes it move to the right slower

	print "INIT ",pc	;
	LDA $E4,x		;
	SEC			;
	SBC #22			;38 pixel interaction field -16 -6
	STA $E4,x		;
	LDA $14E0,x		;
	SBC #$00		;Required to avoid screw ups
	STA $14E0,x		;
	RTL			;

	print "MAIN ",pc	;
	PHB : PHK : PLB		;
	JSR Soda		;
	PLB			;
	RTL			;

YSpdTbl:			;
db $00,$30,$CF			;Format = Idle,Down,Up

Return:	RTS			;
Soda:				;
	JSR GFX			;

	LDA $14C8,x		;
	CMP #$08		;
	BNE Return		;
	LDA $9D			;
	BNE Return		;

	LDA #$20		;Sitting Pose
	STA $13E0		;

	LDA #$01		;Mario's Direction
	STA $76			;Always Right

	LDA #$50		;Always have an X speed moving you to the right
	STA $B6,x		;-->

	LDA $15			;Change Y speed depending on pressing up or down
	REP 2 : LSR		;
	AND #$03		;
	TAY			;
	LDA YSpdTbl,y		;
	STA $AA,x		;

	JSL $018022		;Update X no gravity
	JSL $01801A		;Update Y no gravity

	LDA $E4,x		;Sprite Xpos Low
	CLC			;
	ADC #16			;
	STA $94			;Mario's X position (level)
	LDA $14E0,x		;Sprite Xpos High
	ADC #$00		;
	STA $95			;Mario's X position (next frame)
	LDA $D8,x		;Sprite Ypos Low
	SEC			;
	SBC #28			;
	STA $96			;Mario's Y position (level)
	LDA $14D4,x		;Sprite Ypos High
	SBC #$00		;
	STA $97			;Mario's Y position (next frame)

	JSR Stardust		;Show Star Sparkle Effect

	RTS			;Return To Sender

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;GFX Routine				;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP:	db $82,$80	;Tiles to use in SP3/4
XDISP:		db $16,$06	;X disposition
GFX:				;
	JSR GET_DRAW_INFO	;
	PHX			;
	LDX #$01		;X = number of 16x16 tiles -1
.Loop				;
	LDA $00			;Draw the X position of the sprite
	CLC			;
	ADC XDISP,x		;
	STA $0300,y		;
	LDA $01			;Ypos of sprite
	STA $0301,y		;
	LDA TILEMAP,x		;Tiles to use in SP3/4
	STA $0302,y		;
	LDA #$3B		;YXPPCCCT
	ORA $64			;Green, High Priority, SP3/4
	STA $0303,y		;
	REP 4 : INY		;
	DEX			;
	BPL .Loop		;Loop until X becomes negative (FF).
	PLX			;Restore sprite index
	LDY #$02		;02 = 16x16
	LDA #$01		;tiles drawn - 1
	JSL $01B7B3		;Call the routine that draws the sprite.
	RTS			;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Freaking Huge GET_DRAW_INFO		;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPR_T1:
	db $0C,$1C
SPR_T2:
	db $01,$02
GET_DRAW_INFO:
	STZ $186C,x
	STZ $15A0,x
	LDA $E4,x
	CMP $1A
	LDA $14E0,x
	SBC $1B
	BEQ ON_SCREEN_X
	INC $15A0,x
ON_SCREEN_X:
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$20
	SEC
	SBC $1A
	CLC
	ADC #$0040
	CMP #$0180
	SEP #$20
	ROL A
	AND #$01
	STA $15C4,x
	BNE INVALID
	LDY #$00
	LDA $1662,x
	AND #$20
	BEQ ON_SCREEN_LOOP
	INY
ON_SCREEN_LOOP:
	LDA $D8,x
	CLC
	ADC SPR_T1,y
	PHP
	CMP $1C
	ROL $00
	PLP
	LDA $14D4,x
	ADC #$00
	LSR $00
	SBC $1D
	BEQ ON_SCREEN_Y
	LDA $186C,x
	ORA SPR_T2,y
	STA $186C,x
ON_SCREEN_Y:  
	DEY
	BPL ON_SCREEN_LOOP
	LDY $15EA,x
	LDA $E4,x
	SEC
	SBC $1A
	STA $00
	LDA $D8,x
	SEC
	SBC $1C
	STA $01
	RTS
INVALID:
	PLA
	PLA
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Freaking Huge SUB_OFF_SCREEN		;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPR_T12:
db $40,$B0
SPR_T13:
db $01,$FF
SPR_T14:
db $30,$C0,$A0,$C0,$A0,$F0,$60,$90
db $30,$C0,$A0,$80,$A0,$40,$60,$B0
SPR_T15:
db $01,$FF,$01,$FF,$01,$FF,$01,$FF
db $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X1:
	LDA #$02
	BRA STORE_03
SUB_OFF_SCREEN_X2:
	LDA #$04
	BRA STORE_03
SUB_OFF_SCREEN_X3:
	LDA #$06
	BRA STORE_03
SUB_OFF_SCREEN_X4:
	LDA #$08
	BRA STORE_03
SUB_OFF_SCREEN_X5:
	LDA #$0A
	BRA STORE_03
SUB_OFF_SCREEN_X6:
	LDA #$0C
	BRA STORE_03
SUB_OFF_SCREEN_X7:
	LDA #$0E
STORE_03:
	STA $03
	BRA START_SUB
SUB_OFF_SCREEN_X0:
	STZ $03
START_SUB:
	JSR SUB_IS_OFF_SCREEN
	BEQ RETURN_35
	LDA $5B
	AND #$01
	BNE VERTICAL_LEVEL
	LDA $D8,x
	CLC
	ADC #$50
	LDA $14D4,x
	ADC #$00
	CMP #$02
	BPL ERASE_SPRITE
	LDA $167A,x
	AND #$04
	BNE RETURN_35
	LDA $13
	AND #$01
	ORA $03
	STA $01
	TAY
	LDA $1A
	CLC
	ADC SPR_T14,y
	ROL $00
	CMP $E4,x
	PHP
	LDA $1B
	LSR $00
	ADC SPR_T15,y
	PLP
	SBC $14E0,x
	STA $00
	LSR $01
	BCC SPR_L31
	EOR #$80
	STA $00
SPR_L31:
	LDA $00
	BPL RETURN_35
ERASE_SPRITE:
	LDA $14C8,x
	CMP #$08
	BCC KILL_SPRITE
	LDY $161A,x
	CPY #$FF
	BEQ KILL_SPRITE
	LDA #$00
	STA $1938,y
KILL_SPRITE:
	STZ $14C8,x
RETURN_35:
	RTS
VERTICAL_LEVEL:
	LDA $167A,x
	AND #$04
	BNE RETURN_35
	LDA $13
	LSR A
	BCS RETURN_35
	LDA $E4,x
	CMP #$00
	LDA $14E0,x
	SBC #$00
	CMP #$02
	BCS ERASE_SPRITE
	LDA $13
	LSR A
	AND #$01
	STA $01
	TAY
	LDA $1C
	CLC
	ADC SPR_T12,y
	ROL $00
	CMP $D8,x
	PHP
	LDA $001D
	LSR $00
	ADC SPR_T13,y
	PLP
	SBC $14D4,x
	STA $00
	LDY $01
	BEQ SPR_L38
	EOR #$80
	STA $00
SPR_L38:
	LDA $00
	BPL RETURN_35
	BMI ERASE_SPRITE
SUB_IS_OFF_SCREEN:
	LDA $15A0,x
	ORA $186C,x
	RTS

Stardust:
	JSR IS_SUB_OFFSCREEN
	BNE Endstar
	LDA $1504,x
	AND #$03
	BNE Endstar
	JSL $01ACF9
	AND #$0F
	CLC
	LDY #$00
	ADC #$FC
	BPL If_Plus
	DEY
If_Plus:
	CLC
	ADC $E4,x
	STA $02
	TYA
	ADC $14E0,x
	PHA
	LDA $02
	CMP $1A
	PLA
	SBC $1B
	BNE Endstar
	LDA $148E
	AND #$0F
	CLC
	ADC #$FE
	ADC $D8,x
	STA $00
	LDA $14D4,x
	ADC #$00
	STA $01
	JSL $0285BA
Endstar:
	RTS

IS_SUB_OFFSCREEN:		;Accumulator will be
	LDA $15A0,x		;NON-ZERO
	ORA $186C,x		;If you are off-screen
	RTS			;Return To Sender